# -*- coding: utf-8 -*-
from setuphelpers import *


bin_name_x64 = "vcredist_x64.exe"
bin_name_x86 = "vcredist_x86.exe"
url_dl_x64 = "https://download.microsoft.com/download/5/D/8/5D8C65CB-C849-4025-8E95-C3966CAFD8AE/vcredist_x64.exe"
url_dl_x86 = "https://download.microsoft.com/download/5/D/8/5D8C65CB-C849-4025-8E95-C3966CAFD8AE/vcredist_x86.exe"


def update_package():
    # Initializing variables
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()

    # Downloading binaries
    print("Downloading " + bin_name_x64)
    wget(url_dl_x64, bin_name_x64, proxies=proxies)
    print("Downloading " + bin_name_x86)
    wget(url_dl_x86, bin_name_x86, proxies=proxies)
    temp_dir = bin_name_x86.split(".")[0]
    unzip_with_7zip(bin_name_x86, temp_dir)
    version = get_version_from_binary(makepath(temp_dir, "vc_red.msi"))
    remove_tree(temp_dir)

    # Changing version of the package
    control.version = "%s-%s" % (version, int(control.version.split("-")[-1]))
    control.save_control_to_wapt()
    print("Changing package version to: %s in WAPT\\control" % control.version)
